/*
 *        @(#)Htt.h 1.4 91/09/01  
 * 
 * Delived from @(#)Xfeoak.h	2.1 91/08/13 11:28:54 FUJITSU LIMITED. 
 */
/****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Riki	Kawaguchi	FUJITSU LIMITED
	Tomoki	Kuriki		FUJITSU LIMITED
	Hideki  Hiura           (hhiura@Sun.COM) Sun Microsystems, Inc.
	
****************************************************************************/

#ifndef lint
#ifdef sccs
static char     sccsid[] = "@(#)Htt.h	1.40 93/03/23 SMI";
#endif
#endif


#ifndef _HTT_H_
#define _HTT_H_

#include <X11/Xlib.h>
#include <X11/Xresource.h>
#if XlibSpecificationRelease != 5
#include <X11/XlibR5.h>
#endif /* XlibSpecificationRelease */
#include "XSunExt.h"
#include "HttXsfSun.h"
#include "XSunIMProt.h"
#include "XSunIMPriv.h"
#include "XSunIMMMan.h"

#ifdef NO_GETTEXT
#define dgettext(a,b) (b)
#define bindtextdomain(a,b)
#endif

/*
 * $@%G!<%?9=B$$r3,AX2=$7$F@0M}$7$h$&(J
 */

#define MAXSTYLES 20

typedef struct _im {
    struct _im *next ;
    struct _im *prev ;
    void       *htt ; /* should be used with cast (im_t *) */
} im_t ;			 


typedef struct _htt {
    im_t         *im ;
    XrmDatabase	app_defaults;
    XrmDatabase	special;
    XrmDatabase	cmdlines;
    XrmDatabase	rdb;
    struct _ic        *ic_list;	 
    struct _ic        *free_ic_list;
    char	      *command_name;
    char	      *class_name;
    struct _htt_core  *core;
    unsigned long biff;
} htt_t ;

/*
 * for update indicatator
 */
#define LUCSTYLE       0x00000001
#define LUCNROWS       0x00000002
#define LUCNCOLUMNS    0x00000004
#define STATUSFEEDBACK 0x00000008


#include "XSunIMMthd.h"
#include "XSunIMCore.h"


#ifdef SVR4
#ifndef bcopy
#define bcopy(a,b,c) memmove(b,a,c)
#endif
#ifndef bzero
#define bzero(a,b) memset(a,0,b)
#endif
#ifndef bcmp
#define bcmp(a,b,c) memcmp(a,b,c)
#endif
#ifndef index
#define index(a,b) strchr(a,b)
#endif
#ifndef rindex
#define rindex(a,b) strrchr(a,b)
#endif
#else
extern void bcopy();
extern void bzero();
extern int bcmp();
#endif

#ifndef	XIMP35
typedef unsigned long   		XIMStyle2;
#endif	/* XIMP35 */

#include "XIMProto.h"

#define	FPRT_XIM		0x01
#define	FPRT_XJP		0x02

#define	FIMP_DESTROY		0x00
#define	FIMP_CREATE		0x01
#define	FIMP_BEGIN		0x02
#define	FIMP_SETFOCUS		0x04

#define FS_HIRAGANA		0x01
#define FS_KATAKANA		0x02
#define FS_KANA			0x03
#define FS_UPPER_ASCII		0x04
#define FS_LOWER_ASCII		0x08
#define FS_ASCII		0x0C

#define XSF_COMMIT_CMSG    	15
#define XSF_COMMIT_CMSG_MAX	30
#define XSF_WIDTH_SPACING	5

#define FXIMP_LINEBUFF_LENGTH   42
#define FXIMP_MAX_CLIENT_NO  	1024

#define FINF_NONE		0
#define FINF_ADD		1
#define FINF_MODY		2

#define FKEY_NONE		0
#define FKEY_G_OYA		1
#define FKEY_G_JIS		2

#define FF_FONT_LOAD		0x01
#define FF_CREATE_GC		0x10

#define FC_SAME_ROOT_PREEDIT_WINDOW	0x01
#define FC_SAME_ROOT_PREEDIT_GC		0x02
#define FC_SAME_ROOT_PREEDIT_FONT	0x04
#define FC_SAME_ROOT_PREEDIT		0x07

#define FC_SAME_ROOT_STATUS_WINDOW	0x10
#define FC_SAME_ROOT_STATUS_GC		0x20
#define FC_SAME_ROOT_STATUS_FONT	0x40
#define FC_SAME_ROOT_STATUS		0x70

#define	FC_USE_IMS_PREEDIT_WINDOW	0x01
#define FC_USE_IMS_PREEDIT_GC		0x02
#define FC_USE_IMS_PREEDIT_FONT		0x04
#define FC_USE_IMS_PREEDIT		0x07

#define FC_USE_IMS_STATUS_WINDOW	0x10
#define FC_USE_IMS_STATUS_GC		0x20
#define FC_USE_IMS_STATUS_FONT		0x40
#define FC_USE_IMS_STATUS		0x70

#define	FC_USE_IMS_WINDOW	(FC_SAME_IMS_PREEDIT | FC_SAME_IMS_STATUS)

#define FACT_TYPE1              1
#define FACT_TYPE2              2

/* CallBack Property Name / Type	X11R5	 */
#ifndef  _XIMP_COMMIT
#define  _XIMP_COMMIT				"_XIMP_COMMIT_"
#endif
#ifndef  _XIMP_CALLBACKS
#define  _XIMP_CALLBACKS			"_XIMP_CALLBACKS_"
#define MAX_CALLBACKS_PROP	500
#define CALLBACKS_PROPNAME_LEN	30
#endif
#ifndef  _XIMP_LOOKUP_1
#define  _XIMP_LOOKUP_1				"_XIMP_LOOKUP_1_"
#endif
#ifndef  _XIMP_LOOKUP_2
#define  _XIMP_LOOKUP_2				"_XIMP_LOOKUP_2_"
#endif
#ifndef  _XIMP_LOOKUP_3
#define  _XIMP_LOOKUP_3				"_XIMP_LOOKUP_3_"
#endif
#ifndef  _XIMP_LOOKUP
#define  _XIMP_LOOKUP				"_XIMP_LOOKUP_"
#endif
#ifndef  _XIMP_EXT_XIMP_CHOICE_START_REQ
#define  _XIMP_EXT_XIMP_CHOICE_START_REQ       "_XIMP_EXT_XIMP_CHOICE_START_REQ"
#endif
#ifndef  _XIMP_EXT_XIMP_CHOICE_START_REP
#define  _XIMP_EXT_XIMP_CHOICE_START_REP       "_XIMP_EXT_XIMP_CHOICE_START_REP"
#endif
#ifndef  _XIMP_EXT_XIMP_CHOICE_DRAW_REQ
#define  _XIMP_EXT_XIMP_CHOICE_DRAW_REQ		"_XIMP_EXT_XIMP_CHOICE_DRAW_REQ"
#endif
#ifndef  _XIMP_EXT_XIMP_CHOICE_PROC_REQ
#define  _XIMP_EXT_XIMP_CHOICE_PROC_REQ		"_XIMP_EXT_XIMP_CHOICE_PROC_REQ"
#endif
#ifndef  _XIMP_EXT_XIMP_CHOICE_PROC_REP
#define  _XIMP_EXT_XIMP_CHOICE_PROC_REP		"_XIMP_EXT_XIMP_CHOICE_PROC_REP"
#endif
#ifndef  _XIMP_EXT_XIMP_LOOKUPCHOICES
#define  _XIMP_EXT_XIMP_LOOKUPCHOICES		"_XIMP_EXT_XIMP_LOOKUPCHOICES"
#endif

#ifdef XIMP_PREEDIT_MAX_LONG_BC
#define	XIMP_PREEDIT_MAX_LONG_BC		14
#endif					/* XIMP_PREEDIT_MAX_LONG_BC */
#ifdef XIMP_PREEDIT_MAX_CHAR_BC
#define	XIMP_PREEDIT_MAX_CHAR_BC		56
#endif					/* XIMP_PREEDIT_MAX_CHAR_BC */
#ifdef XIMP_STATUS_MAX_LONG_BC
#define	XIMP_STATUS_MAX_LONG_BC			13
#endif					/* XIMP_STATUS_MAX_LONG_BC */
#ifdef XIMP_STATUS_MAX_CHAR_BC
#define	XIMP_STATUS_MAX_CHAR_BC			52
#endif					/* XIMP_STATUS_MAX_CHAR_BC */

#define	XSF_PRE_MASK_BC		\
	( XIMP_PRE_AREA_MASK_BC | XIMP_PRE_FG_MASK_BC | XIMP_PRE_BG_MASK_BC | \
	  XIMP_PRE_COLORMAP_MASK_BC | XIMP_PRE_BGPIXMAP_MASK_BC |	      \
	  XIMP_PRE_LINESP_MASK_BC | XIMP_PRE_CURSOR_MASK_BC |		      \
	  XIMP_PRE_AREANEED_MASK_BC | XIMP_PRE_SPOTL_MASK_BC )
#define	XSF_PRE_MASK		\
	( XIMP_PRE_AREA_MASK | XIMP_PRE_FG_MASK | XIMP_PRE_BG_MASK |	      \
	  XIMP_PRE_COLORMAP_MASK | XIMP_PRE_BGPIXMAP_MASK |		      \
	  XIMP_PRE_LINESP_MASK | XIMP_PRE_CURSOR_MASK |			      \
	  XIMP_PRE_AREANEED_MASK | XIMP_PRE_SPOTL_MASK )
#define	XSF_STS_MASK_BC		\
	( XIMP_STS_AREA_MASK_BC | XIMP_STS_FG_MASK_BC | XIMP_STS_BG_MASK_BC | \
	  XIMP_STS_COLORMAP_MASK_BC | XIMP_STS_BGPIXMAP_MASK_BC |	      \
	  XIMP_STS_LINESP_MASK_BC | XIMP_STS_CURSOR_MASK_BC |		      \
	  XIMP_STS_AREANEED_MASK_BC | XIMP_STS_WINDOW_MASK_BC )
#define	XSF_STS_MASK		\
	( XIMP_STS_AREA_MASK | XIMP_STS_FG_MASK | XIMP_STS_BG_MASK |	      \
	  XIMP_STS_COLORMAP_MASK | XIMP_STS_BGPIXMAP_MASK |		      \
	  XIMP_STS_LINESP_MASK | XIMP_STS_CURSOR_MASK |			      \
	  XIMP_STS_AREANEED_MASK | XIMP_STS_WINDOW_MASK )


typedef struct _FXimpFont {
    GC              normal_gc ;
    GC              reverse_gc ;
    GC              invert_gc ;
    XFontSet	    font_set ;
    short           max_font_width ;
    short           max_font_height ;
    short           max_font_descent ;
    short           max_font_ascent ;
    unsigned char   status ;
} FXimpFont;

/* Preedit Window records */
typedef	struct	_Htt_PreeditWinRec {
    struct _Htt_PreeditWinRec  *next_link;
    struct _Htt_PreeditWinRec  *back_link;
    unsigned long               status;
    Window                      win_part;
    unsigned int                start_pos;
    unsigned int                draw_char_len;
    unsigned int		old_width;
    unsigned int		current_width;
    XRectangle                  area_part;
} Htt_PreeditWinRec ;

/* PreeditWinRec <status> value define */
#define	PREEDITWIN_CREATE       (1<<0)
#define	PREEDITWIN_MAP          (1<<1)
#define	PREEDITWIN_MODIFY       (1<<2)
#define	PREEDITWIN_ROOT         (1<<3)
#define	PREEDITWIN_LINKED       (1<<4)

#define stipple 0
#define highlight 1

typedef	struct _PreeditCaret {
    struct _PreeditCaret  *next;
    int		point;
    int		screen;
    Pixmap	pixmap;
    Pixmap	shape_mask;
    Pixmap	saved_image;
    unsigned long	bg;
    GC		gc;
    int		width;
    int		height;
} PreeditCaret;

/* Preedit Text records */
typedef	struct	_Htt_PreeditTextRec {
    Bool                        preedit_over;
    int                         caret_pos;
    int                         preedit_char_len;
    int                         chg_first;
    wchar_t                    *preedit_char;
    XIMFeedback                *preedit_attr;
    Htt_PreeditWinRec          *cursor_in;
    Window			caret_win;
    int				caret_x;
    int				caret_y;
    Bool			caret_mapped;
    PreeditCaret	       *caret;
} Htt_PreeditTextRec ;

typedef struct _XsfClientFunc {
    int             (*preedit_start) ();
    int             (*preedit_draw) ();
    int             (*preedit_caret) ();
    int             (*preedit_done) ();
    int             (*status_start) ();
    int             (*status_draw) ();
    int             (*status_done) ();
    int             (*lookup_start) ();
    int             (*lookup_draw) ();
    int             (*lookup_process) ();
    int             (*lookup_done) ();
    int             (*aux_start) ();
    int             (*aux_draw) ();
    int             (*aux_done) ();
}               XsfClientFunc;

typedef struct _HttIcidLinkRec {
    struct _HttIcidLinkRec      *next;
    struct _HttIcidLinkRec      *prev;
    struct _FXimp_Client        *icid;
} HttIcidLinkRec;

typedef struct _HttFocusWindowRec {
    struct _HttFocusWindowRec   *next;
    struct _HttFocusWindowRec	*prev;
    Window                       focus_window;
    short                        count;
    HttIcidLinkRec              *icid_link;
    struct _FXimp_Client        *current_icid;
} HttFocusWindowRec;

typedef struct _outgoing_keypress {
    long keycode ;
    long state ;
} outgoing_keypress_t ;

typedef struct _FXimp_Client {
    Window          window;
    int             screen;
    long            input_mask ;
    XIMStyle        style;
    XIMStyle2       style2;
    unsigned long   ximp_version;
    unsigned char   prot_type;
    unsigned char   imp_mode;
    unsigned char   ext_ui_back_front;
    unsigned char   frontend_key_press_mask;
    unsigned char   ext_ui_statuswindow;
    unsigned char   action_type;
    unsigned char   window_type;
    unsigned char   ims_window_type;
    unsigned char   check_preedit_area_size;
    unsigned char   reserved1;
    unsigned char   reserved2;
    unsigned char   reserved3;
    HttFocusWindowRec   *focus_window_rec;
    Ximp_PreeditPropRec *preedit;
    Ximp_StatusPropRec  *status;
    Ximp_AreaRec        *ims_area;
    Ximp_AreaRec	*ims_preedit;
    char           *preedit_fontname;
    char           *status_fontname;
    FXimpFont      *preedit_font;
    FXimpFont      *status_font;
    Atom            ximp_readprop_atom;
    Window          focus_window;
    Window          preedit_window;
    Window          status_window;
    Window          lookup_window;
    Window          ims_status_window;
    Htt_PreeditWinRec *preedit_window_info;
    Htt_PreeditWinRec *linked_preedit_window_info;
    unsigned char   preedit_visible;
    unsigned char   status_visible;
    unsigned char   henkan_mode;
    unsigned char   siftmode;
    unsigned char   romaji_mode;
    unsigned char   hankakumode;
    unsigned char   physical_kanashift;
    unsigned char   logical_kanashift;
    unsigned char   logical_capslock;
    unsigned char   stage;	/* reserved */
    unsigned char   select_kanji_no;
    unsigned char   select_kanji_mod;
    unsigned long   old_state;
    Bool	    xnarea_set;
    Bool	    keypress_hold;
    Htt_PreeditTextRec preedit_text;
    unsigned short *input_buff;
    short           input_flag;
    short           dummy;
    XPointer	    lookup_data;	/* lookup data attached to each IC */
    /* Public IMServer Engine Interface */
    outgoing_keypress_t outgoing_keypress ;
    wchar_t	   *status_message ;
    int		    status_length ;
    int             callback_flg;
    unsigned int    lookup_choice;
    /* Private SunImLogic Interface */
    iml_session_t  *s;
    XSFrrvCell     *cell_link;
    iml_status_t    iml_status;
    XsfClientFunc   func;
    iml_if_t        *If ;
    /* Link to core htt */
    htt_t	    *ims;
}               FXimp_Client;

typedef struct _FXimp_Client *FXimp_ICID;

#define	IMS_OF_CLIENT(ic)	(ic)->ims

/*
 *  IC link
 */
typedef struct _ic {
    struct _ic	*next;
    struct _ic 	*prev;
    im_t       	*im;
    FXimp_ICID   core_ic;
    void       	*if_ic;
} ic_t ;


#define CORE_IC_REC(ic) 	 (FXimp_ICID)((ic)->core_ic)
#define	HTT_CORE(htt)	(htt)->core
#define	GET_HTT_VALUE(htt, field)	((htt)->core->field)
#define	SET_HTT_VALUE(htt, field, val)	((htt)->core->field = (val))
				
#define	CURRENT_CLIENT(htt)	(htt)->core->current_client	

typedef struct _htt_core {
    Display      *display;
    int           screen;
    Window        root;
    FXimp_Client *focus_in_client;
    FXimp_Client *previous_focus_in_client;
    FXimp_Client *current_client;
    FXimp_Client *root_client;
    FXimp_Client *previous_client;
    XFontStruct	 *glyph_font;
    Bool	ims_window_mapped;

    char	*font_name;
    char	*glyph_name;

    char	*foreground_color;
    char	*background_color;
    char	*border_color;
    char	*caret_color;
    char	*rootgeometry;
    char	*icon_geometry;
    char	*background_pixmap;
    int		bd_width;

    Atom	IMA_IMPROTOCOL;

    char		*locale_name;
    unsigned char	*vendor_name;
    unsigned char	*server_name;
    unsigned char	*server_version;
    unsigned char	*server_full_name;
    
    int         preedit_over_mode;
    int		preedit_feedback;
    int		status_feedback;

    int		status_pos;

    int		max_preedit_line;
    int		line_spacing;
    int		ims_line;
    int		ims_preedit_line;
    int		ims_preedit_column;

    int         lookup_takeover;
    int         status_root_maxwidth;

    short       keybord_type;
    Bool        client_is_cmsg_only;
    PreeditCaret	*preedit_caret;
    PreeditCaret	*root_preedit_caret;
    Window		root_caret_win;
    Window		root_client_wid;
    XPointer    lookup_info;
    XIMStyle    styles[MAXSTYLES] ;
    int         nstyles ;
    pid_t       htt_pid  ;
    pid_t       htt_prop_pid  ;
    pid_t       htt_master_pid ;
    Bool        norestart ;
    Bool        noprops ;

    int         too_fast_restart_count;
} HttCore, *HttRec;


#define	HTT_INT_T	1
#define	HTT_STR_T	2
#define	HTT_ENUM_T	3

#define HttOffset(p_type,field) ((unsigned int)&(((p_type)NULL)->field))

typedef struct _htt_resource_enums {
    char	*name;
    int		val;
} HttResourceEnums;

typedef	struct _htt_resources {
    char	*name;
    char	*class;
    int		offset;
    int		type;
    HttResourceEnums	*enumtab;
    XPointer	default_value;
} HttResources;


/*
 * Ximp Version define
 */
#define	XIMP_PROTO_35_GRP		0
#define	XIMP_PROTO_40_GRP		1

/*
 * preedit_over_mode's define
 */
#define	PREEDIT_OVER_NON        0
#define	PREEDIT_OVER_SCROLL     1
#define	PREEDIT_OVER_EXTENT     2

#define	FEEDBACK_NONE		1
#define FEEDBACK_UNMAP		2
#define	FEEDBACK_STIPPLE	3

#define STATUS_LEFT	0
#define STATUS_RIGHT	1


int             InitialClientTable();
int             ExitClientTable();
FXimp_Client   *NewClient();
int             DeleteClient();
FXimp_Client   *FindClient();
FXimp_Client   *FindClientByICID();
FXimp_Client   *FindClientByFocusWindow();
FXimp_Client   *FindClientByPreeditOrStatusWindow();
FXimp_Client   *FindClientByPreeditOrStatusWindowForRedisplay();
unsigned short  Hankaku_To_ZenkakuAsciiHiragana();
void            ErrorMessage();
void            WarningMessage();

#define KS_TOP          1
#define KS_BOTTOM       2
#define KS_FOWARD       3
#define KS_BACKWARD     4
#define KS_NEXT         5
#define KS_PREV         6

#ifdef DEBUG
#define Static			/**/
#else
#define Static static
#endif

#ifdef	DEBUG
#define	DBG_printf(from, d1, d2, d3, d4, d5, d6, d7, d8, d9, d10, d11, d12, d13, d14, d15, d16) \
	dbg_printf(from, d1, d2, d3, d4, d5, d6, d7, d8, d9, d10, d11, d12, d13, d14, d15, d16)
#else
#define	DBG_printf(from, d1, d2, d3, d4, d5, d6, d7, d8, d9, d10, d11, d12, d13, d14, d15, d16)
#endif	/* DEBUG */

#ifndef MIN
#define	MIN(a,b)	( a < b ? a : b )
#endif
#ifndef MAX
#define	MAX(a,b)	( a > b ? a : b )
#endif

#ifdef	SVR4
#define HTT_MSG(str)    \
	fprintf(stderr, dgettext("htt.message", (str)))
#else   /* SVR4 */
#define HTT_MSG(str)    \
	fprintf(stderr, (str));
#endif	SVR4

Bool iml_open() ;
#endif /* _HTT_H_ */
