#ifndef lint
#ifdef sccs
static char     sccsid[] = "HttWchar.c 1.5" ;
#endif
#endif
/******************************************************************

              Copyright 1990, 1991, by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of Sun Microsystems, Inc.
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.
Sun Microsystems, Inc. makes no representations about the suitability of
this software for any purpose.  It is provided "as is" without
express or implied warranty.

Sun Microsystems Inc. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL Sun Microsystems, Inc. BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

  Author: Hideki Hiura (hhiura@Sun.COM)
	  				     Sun Microsystems, Inc.
******************************************************************/
#include <stdio.h>
#include <X11/Xlib.h>
#include "HttWchar.h"
#ifdef SVR4
#else /* SVR4 */

wchar_t *
wscpy(s1, s2)
register wchar_t *s1 ;
register wchar_t *s2 ;
{
    wchar_t        *s = s1;
    while ((*s++ = *s2++) != '\0') ;
    return (s1);
}
wchar_t *
wscat(s1, s2)
register wchar_t *s1;
register wchar_t *s2;
{
    wchar_t        *s = s1;
    while (*s++);
    while ((*s++ = *s2++) != '\0') ;
    return (s1);
}

wchar_t *
wsdup(s1)
register wchar_t *s1;
{
    char           *malloc();
    wchar_t        *s ;
    register wchar_t *s2;

    s = s2 = (wchar_t *) calloc(sizeof(wchar_t), (unsigned) wslen(s1) + 1);

    if (s != (wchar_t *) 0) {
	while ((*s2++ = *s1++) != '\0') ;
    }
    return (s);
}

wchar_t *
wstrncat(s1, s2, l)
register wchar_t *s1;
register wchar_t *s2;
register int    l;
{
    wchar_t        *s = s1;
    while (*s1++);
    
    while (l-- && ((*s1++ = *s2++) != (wchar_t) '\0'));
    if (!l) *s1 = (wchar_t) '\0';

    return (s);
}

int
wscmp(s1, s2)
register wchar_t *s1;
register wchar_t *s2;
{
    while (*s1 && (*s1 == *s2)) {
	s1++;
	s2++;
    }
    return (*s1 - *s2);
}

int
wsncmp(s1, s2, l)
register wchar_t *s1;
register wchar_t *s2;
register int    l;
{
    while (--l && *s1 && (*s1 == *s2)) {
	s1++;
	s2++;
    }
    return (*s1 - *s2);
}

wchar_t *
wsncpy(s1, s2, l)
register wchar_t *s1;
register wchar_t *s2;
register int    l;
{
    wchar_t        *s = s1;
    while ((l-- > 0) && (*s1++ = *s2++) != '\0') ;
    while ((l-- > 0)) *s1++ = '\0';
    return s;
}

int
wslen(s1)
wchar_t *s1;
{
    register wchar_t *s= s1;
    while(*s++) ;
    return (s - s1) ;
}

wchar_t *
wschr(s1, c)
register wchar_t *s1;
register int    c;
{
    while (*s1 && (*s1 != (wchar_t) c)) {
	s1++;
    }
    
    if ((!*s1) && c) {
	s1 = (wchar_t *) 0;
    }
    return (s1);
}

wchar_t        *
wsrchr(s1, c)
register wchar_t *s1;
register int    c;
{
    register wchar_t *s = (wchar_t *) 0;

    while (*s1) {
	if (*s1 == (wchar_t) c) {
	    s = s1;
	}
	s1++;
    }
    return (s);
}


wchar_t *
wspbrk(s1, s2)
register wchar_t *s1;
register wchar_t *s2;
{
    register wchar_t *s;
    while (*s1) {
	for (s = s2; *s && *s != *s1; s++) {
	}
	if (*s) {
	    break;
	}
	s1++;
    }
    
    if (!*s1) {
	s1 = (wchar_t *) 0;
    }
    return s1;
}

int
wsspn(s1, s2)
register wchar_t *s1;
register wchar_t *s2;
{
    register wchar_t *s;
    wchar_t        *orig = s1;
    
    while (*s1) {
	for (s = s2; *s && *s != *s1; s++) {
	}
	if (!*s) {
	    break;
	}
	s1++;
    }
    
    return ((int) (s1 - orig));
}

int
wscspn(str1, str2)
	register wchar_t *str1;
	register wchar_t *str2;
{
	register wchar_t *tmp;
	wchar_t        *orig = str1;

	while (*str1) {
		for (tmp = str2; *tmp && *tmp != *str1; tmp++) {
		}
		if (*tmp) {
			break;
		}
		str1++;
	}

	return ((int) (str1 - orig));
}
	
wchar_t *
wcscpy (s1,s2){
	return wscpy(s1,s2);
}
int
wcslen (s1){
	return wslen(s1) ;
}
malloc_check_data (){}
int
wcscmp (s1,s2){
	return wscmp(s1, s2);
}
int
wcstol(s){
	return wstol(s);
}
long
wstol(){ 
    printf("Warning: wstol() is not supported\n");
    return 0;
}
unsigned long
mbstowcs(wcs, mbs, n)
wchar_t *wcs;
char *mbs;
int n;
{
    return _Xmbstowcs(wcs, mbs, n);
}
unsigned long
wcstombs(mbs, wcs, n)
char *mbs;
wchar_t *wcs;
int n;
{
    return _Xwcstombs(mbs, wcs, n);
}
int
mblen(str, len)
char *str;
int len;
{
    return _Xmblen(str, len);
}
int
mbtowc(wstr, str, len)
    wchar_t *wstr;
    char *str;
    int len;
{
    return _Xmbtowc(wstr, str, len);
}
int
wctomb(str, wc)
    char *str;
    wchar_t wc;
{
    return _Xwctomb(str, wc);
}
wchar_t *
wcsncpy(s1,s2, n)
{
	return wsncpy(s1, s2, n);
}

/*
 * Copyright (c) 1989 The Regents of the University of California. All rights
 * reserved.
 * 
 * Redistribution and use in source and binary forms are permitted provided that
 * the above copyright notice and this paragraph are duplicated in all such
 * forms and that any documentation, advertising materials, and other
 * materials related to such distribution and use acknowledge that the
 * software was developed by the University of California, Berkeley.  The
 * name of the University may not be used to endorse or promote products
 * derived from this software without specific prior written permission. THIS
 * SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Get next token from string s (NULL on 2nd, 3rd, etc. calls), where tokens
 * are nonempty strings separated by runs of chars from delim.  Writes NULs
 * into s to end tokens.  delim need not remain constant from call to call.
 * 
 * Modified by cpc: 	changed variable names to conform with naming
 * conventions used in rest of code.  Added malloc pointer check calls.
 */
wchar_t        *
wstok(str1, str2)
	wchar_t        *str1;
	wchar_t        *str2;
{
	static wchar_t *last;
	wchar_t        *wstrtoken();

	if (str1) {
		last = str1;
	}

	return (wstrtoken(&last, str2, 1));
}


/*
 * Get next token from string *stringp, where tokens are (possibly empty)
 * strings separated by characters from delim.  Tokens are separated by
 * exactly one delimiter iff the skip parameter is false; otherwise they are
 * separated by runs of characters from delim, because we skip over any
 * initial `delim' characters.
 * 
 * Writes NULs into the string at *stringp to end tokens. delim will usually,
 * but need not, remain constant from call to call. On return, *stringp
 * points past the last NUL written (if there might be further tokens), or is
 * NULL (if there are definitely no more tokens).
 * 
 * If *stringp is NULL, strtoken returns NULL.
 */
wchar_t        *
wstrtoken(stringp, delim, skip)
	register wchar_t **stringp;
	register wchar_t *delim;
	int             skip;
{
	register wchar_t *s;
	register wchar_t *spanp;
	register int    c, sc;
	wchar_t        *tok;

	if ((s = *stringp) == NULL)
		return (NULL);

	if (skip) {
		/*
		 * Skip (span) leading delimiters (s += wstrspn(s, delim)).
		 */
cont:
		c = *s;
		for (spanp = delim; (sc = *spanp++) != 0;) {
			if (c == sc) {
				s++;
				goto cont;
			}
		}
		if (c == 0) {	/* no token found */
			*stringp = NULL;
			return (NULL);
		}
	}
	/*
	 * Scan token (scan for delimiters: s += wstrcspn(s, delim), sort
	 * of). Note that delim must have one NUL; we stop if we see that,
	 * too.
	 */
	for (tok = s;;) {
		c = *s++;
		spanp = delim;
		do {
			if ((sc = *spanp++) == c) {
				if (c == 0)
					s = NULL;
				else
					s[-1] = 0;
				*stringp = s;
				return (tok);
			}
		} while (sc != 0);
	}
	/* NOTREACHED */
}
#endif /* SVR4 */
